diff --git a/game/client/src/main/java/net/minecraft/client/render/Lighting.java b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
index 4e9a23776..206bd726c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Lighting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
@@ -5,66 +5,67 @@ import static org.lwjgl.opengl.GL11.*;
 import java.nio.FloatBuffer;
 
 import net.minecraft.client.GLAllocation;
-import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3f;
 
 public class Lighting {
+    private static final @NotNull FloatBuffer buffer = GLAllocation.createDirectFloatBuffer(16);
+    private static final @NotNull Vector3f vec = new Vector3f();
 
-	public Lighting() {
-	}
+    public Lighting() {
+    }
 
-	public static void disable() {
-		glDisable(GL_LIGHTING);
-		glDisable(GL_LIGHT0);
-		glDisable(GL_LIGHT1);
-		glDisable(GL_COLOR_MATERIAL);
-	}
+    public static void disable() {
+        glDisable(GL_LIGHTING);
+        glDisable(GL_LIGHT0);
+        glDisable(GL_LIGHT1);
+        glDisable(GL_COLOR_MATERIAL);
+    }
 
-	public static void enableInventoryLight() {
-		glPushMatrix();
-		glRotatef(-30.0f, 0.0F, 1.0F, 0.0F);
-		glRotatef(155.0f, 1.0F, 0.0F, 0.0F);
-		enableLight(0.4f, 0.5f);
-		glPopMatrix();
-	}
+    public static void enableInventoryLight() {
+        glPushMatrix();
+        glRotatef(-30.0f, 0.0F, 1.0F, 0.0F);
+        glRotatef(155.0f, 1.0F, 0.0F, 0.0F);
+        enableLight(0.4f, 0.5f);
+        glPopMatrix();
+    }
 
-	public static void enableLight() {
-		enableLight(0.4f, 0.6f);
-	}
-	
-	public static void enableLight(float ambientBrightness, float lightBrightness) {
-		glEnable(GL_LIGHTING);
-		glEnable(GL_LIGHT0);
-		glEnable(GL_LIGHT1);
-		glEnable(GL_COLOR_MATERIAL);
-		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
-		
-		Vec3 vec = Vec3.fromPool(0.2D, 1.0D, -0.7D).normalize();
-		glLightfv(GL_LIGHT0, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0D));
-		glLightfv(GL_LIGHT0, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
-		glLightfv(GL_LIGHT0, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
-		glLightfv(GL_LIGHT0, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
-		
-		vec = Vec3.fromPool(-0.2D, 1.0D, 0.7D).normalize();
-		glLightfv(GL_LIGHT1, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0D));
-		glLightfv(GL_LIGHT1, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
-		glLightfv(GL_LIGHT1, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
-		glLightfv(GL_LIGHT1, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
-		
-		glShadeModel(GL_FLAT);
-		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, getBuffer(ambientBrightness, ambientBrightness, ambientBrightness, 1.0F));
-	}
+    public static void enableLight() {
+        enableLight(0.4f, 0.6f);
+    }
 
-	private static FloatBuffer getBuffer(double d, double d1, double d2, double d3) {
-		return getBuffer((float) d, (float) d1, (float) d2, (float) d3);
-	}
+    public static void enableLight(float ambientBrightness, float lightBrightness) {
+        glEnable(GL_LIGHTING);
+        glEnable(GL_LIGHT0);
+        glEnable(GL_LIGHT1);
+        glEnable(GL_COLOR_MATERIAL);
+        glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
 
-	private static FloatBuffer getBuffer(float f, float f1, float f2, float f3) {
-		buffer.clear();
-		buffer.put(f).put(f1).put(f2).put(f3);
-		buffer.flip();
-		return buffer;
-	}
+        vec.set(0.2f, 1.0f, -0.7f).normalize();
+        glLightfv(GL_LIGHT0, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0f));
+        glLightfv(GL_LIGHT0, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
+        glLightfv(GL_LIGHT0, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+        glLightfv(GL_LIGHT0, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
 
-	private static final FloatBuffer buffer = GLAllocation.createDirectFloatBuffer(16);
+        vec.set(-0.2f, 1.0f, 0.7f).normalize();
+        glLightfv(GL_LIGHT1, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0f));
+        glLightfv(GL_LIGHT1, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
+        glLightfv(GL_LIGHT1, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+        glLightfv(GL_LIGHT1, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+
+        glShadeModel(GL_FLAT);
+        glLightModelfv(GL_LIGHT_MODEL_AMBIENT, getBuffer(ambientBrightness, ambientBrightness, ambientBrightness, 1.0F));
+    }
+
+    private static @NotNull FloatBuffer getBuffer(double d1, double d2, double d3, double d4) {
+        return getBuffer((float) d1, (float) d2, (float) d3, (float) d4);
+    }
+
+    private static @NotNull FloatBuffer getBuffer(float f1, float f2, float f3, float f4) {
+        buffer.clear();
+        buffer.put(f1).put(f2).put(f3).put(f4);
+        buffer.flip();
+        return buffer;
+    }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
index 5c9300f6e..13ec0ce71 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
@@ -6,95 +6,95 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 final public class LightingCache {
     private final Minecraft mc = Minecraft.getMinecraft();
-    
+
     private static final int CACHE_RANGE = 1;
-    private static final int CACHE_SIZE = CACHE_RANGE*2+1;
-    
-    private final boolean[] brightnessCached = new boolean[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
-    private final float[] brightnessValue = new float[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
-    
-    private final boolean[] opacityCached = new boolean[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
-    private final boolean[] opacityValue = new boolean[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
-    
-    private final boolean[] lightmapCoordCached = new boolean[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
-    private final int[] lightmapCoordValue = new int[CACHE_SIZE*CACHE_SIZE*CACHE_SIZE];
-    
-    private int offsetX = Integer.MAX_VALUE;
-    private int offsetY = Integer.MAX_VALUE;
-    private int offsetZ = Integer.MAX_VALUE;
-    
+    private static final int CACHE_SIZE = CACHE_RANGE * 2 + 1;
+
+    private final boolean[] brightnessCached = new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private final float[] brightnessValue = new float[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+
+    private final boolean[] opacityCached = new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private final boolean[] opacityValue = new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+
+    private final boolean[] lightmapCoordCached = new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private final int[] lightmapCoordValue = new int[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+
+    private final @NotNull TilePos offset = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
+
     private Block<?> block;
     private WorldSource access;
 
-    public void setupCache(Block<?> block, WorldSource access, int x, int y, int z){
-        if(x != offsetX || y != offsetY || z != offsetZ || this.block != block || this.access != access) {
+    @Deprecated
+    public void setupCache(@NotNull Block<?> block, @NotNull WorldSource source, int x, int y, int z) {
+        setupCache(block, source, new TilePos(x, y, z));
+    }
+
+    public void setupCache(@NotNull Block<?> block, @NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        if (!tilePos.equals(this.offset) || this.block != block || this.access != source) {
             this.block = block;
-            this.access = access;
-            Arrays.fill(brightnessCached, false);
-            Arrays.fill(opacityCached, false);
-            Arrays.fill(lightmapCoordCached, false);
-            offsetX = x;
-            offsetY = y;
-            offsetZ = z;
+            this.access = source;
+            Arrays.fill(this.brightnessCached, false);
+            Arrays.fill(this.opacityCached, false);
+            Arrays.fill(this.lightmapCoordCached, false);
+            this.offset.set(tilePos);
         }
     }
-    
-    private float calcBrightness(final int x, final int y, final int z) {
-        final int blockId = this.access.getBlockId(x, y, z);
+
+    private float calcBrightness(final @NotNull TilePos tilePos) {
+        final int blockId = this.access.getBlockId(tilePos);
         final Block<?> block = Blocks.getBlock(blockId);
 
-        if(LightmapHelper.isLightmapEnabled() || this.mc.fullbright) {
-            if(this.block.emission >= 15) {
+        if (LightmapHelper.isLightmapEnabled() || this.mc.fullbright) {
+            if (this.block.emission >= 15) {
                 return 1.0f;
             }
-            if(!this.mc.isAmbientOcclusionEnabled()) {
+            if (!this.mc.isAmbientOcclusionEnabled()) {
                 return 1.0f;
             }
-            if(block == null) {
+            if (block == null) {
                 return 1.0f;
             }
-            return 1.0f - block.getAmbientOcclusionStrength(this.access, x, y, z);
+            return 1.0f - block.getAmbientOcclusionStrength(this.access, tilePos);
         }
         final int emission = Blocks.lightEmission[blockId];
-        final float brightness = this.access.getBrightness(x, y, z, emission);
+        final float brightness = this.access.getBrightness(tilePos, emission);
 
-        return Math.min(brightness, (this.mc.isAmbientOcclusionEnabled() && block != null) ? (1 - block.getAmbientOcclusionStrength(this.access, x, y, z)) : 1);
+        return Math.min(brightness, (this.mc.isAmbientOcclusionEnabled() && block != null) ? (1 - block.getAmbientOcclusionStrength(this.access, tilePos)) : 1);
     }
-    
-	public float getBrightness(int relX, int relY, int relZ) {
-		int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
-		
-		if(!brightnessCached[index]) {
-			int x1 = relX + offsetX;
-			int y1 = relY + offsetY;
-			int z1 = relZ + offsetZ;
-			
-			brightnessValue[index] = calcBrightness(x1, y1, z1);
-			brightnessCached[index] = true;
-		}
-		
-		return brightnessValue[index];
-	}
-	
+
+    public float getBrightness(int relX, int relY, int relZ) {
+        int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
+
+        if (!this.brightnessCached[index]) {
+            this.brightnessValue[index] = calcBrightness(this.offset.add(relX, relY, relZ, new TilePos()));
+            this.brightnessCached[index] = true;
+        }
+
+        return this.brightnessValue[index];
+    }
+
     public boolean getOpacity(int relX, int relY, int relZ) {
-        int index = (relX+CACHE_RANGE)*CACHE_SIZE*CACHE_SIZE+(relY+CACHE_RANGE)*CACHE_SIZE+(relZ+CACHE_RANGE);
-        if(!opacityCached[index]){
-            opacityValue[index] = Blocks.solid[access.getBlockId(relX+ offsetX, relY+ offsetY, relZ+ offsetZ)];
-            opacityCached[index] = true;
+        int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
+        if (!this.opacityCached[index]) {
+            this.opacityValue[index] = Blocks.solid[this.access.getBlockId(this.offset.add(relX, relY, relZ, new TilePos()))];
+            this.opacityCached[index] = true;
         }
-        return opacityValue[index];
+        return this.opacityValue[index];
     }
-    
+
     public int getLightmapCoord(int relX, int relY, int relZ) {
-    	int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
-    	if(!lightmapCoordCached[index]) {
-    		int lightEmission = block.emission;
-    		lightmapCoordValue[index] = access.getLightmapCoord(relX + offsetX, relY + offsetY, relZ + offsetZ, lightEmission);
-    		lightmapCoordCached[index] = true;
-    	}
-    	return lightmapCoordValue[index];
+        int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
+        if (!this.lightmapCoordCached[index]) {
+            int lightEmission = this.block.emission;
+            this.lightmapCoordValue[index] = this.access.getLightmapCoord(this.offset.add(relX, relY, relZ, new TilePos()), lightEmission);
+            this.lightmapCoordCached[index] = true;
+        }
+        return this.lightmapCoordValue[index];
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index affe21f7b..3ef5d30fc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -10,11 +10,12 @@ import net.minecraft.client.render.tessellator.ParticleTessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 /**
@@ -163,7 +164,7 @@ public final class ParticleEngine {
                     double yp = y + (yy + 0.5D) / amount;
                     double zp = z + (zz + 0.5D) / amount;
                     Side side = Side.getSideById(this.rand.nextInt(6));
-                    add((new ParticleBlockBreaking(this.world, xp, yp, zp, xp - x - 0.5D, yp - y - 0.5D, zp - z - 0.5D, block, side, data)).init(x, y, z));
+                    add((new ParticleBlockBreaking(this.world, xp, yp, zp, xp - x - 0.5D, yp - y - 0.5D, zp - z - 0.5D, block, side, data)).init(new TilePos(x, y, z)));
                 }
             }
         }
@@ -183,25 +184,25 @@ public final class ParticleEngine {
             return;
         }
         Block<?> block = Blocks.blocksList[id];
-        AABB bounds = block.getBounds();
+        AABBdc bounds = block.getBounds();
         float r = 0.1F;
-        double xp = x + this.rand.nextDouble() * (bounds.maxX - bounds.minX - (r * 2.0F)) + r + bounds.minX;
-        double yp = y + this.rand.nextDouble() * (bounds.maxY - bounds.minY - (r * 2.0F)) + r + bounds.minY;
-        double zp = z + this.rand.nextDouble() * (bounds.maxZ - bounds.minZ - (r * 2.0F)) + r + bounds.minZ;
+        double xp = x + this.rand.nextDouble() * (bounds.maxX() - bounds.minX() - (r * 2.0F)) + r + bounds.minX();
+        double yp = y + this.rand.nextDouble() * (bounds.maxY() - bounds.minY() - (r * 2.0F)) + r + bounds.minY();
+        double zp = z + this.rand.nextDouble() * (bounds.maxZ() - bounds.minZ() - (r * 2.0F)) + r + bounds.minZ();
         if (side == Side.BOTTOM) {
-            yp = (y + bounds.minY) - r;
+            yp = (y + bounds.minY()) - r;
         } else if (side == Side.TOP) {
-            yp = (y + bounds.maxY) + r;
+            yp = (y + bounds.maxY()) + r;
         } else if (side == Side.NORTH) {
-            zp = (z + bounds.minZ) - r;
+            zp = (z + bounds.minZ()) - r;
         } else if (side == Side.SOUTH) {
-            zp = (z + bounds.maxZ) + r;
+            zp = (z + bounds.maxZ()) + r;
         } else if (side == Side.WEST) {
-            xp = (x + bounds.minX) - r;
+            xp = (x + bounds.minX()) - r;
         } else if (side == Side.EAST) {
-            xp = x + bounds.maxX + r;
+            xp = x + bounds.maxX() + r;
         }
-        add((new ParticleBlockBreaking(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockMetadata(x, y, z))).init(x, y, z).setPower(0.2F).setScale(0.6F));
+        add((new ParticleBlockBreaking(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockMetadata(x, y, z))).init(new TilePos(x, y, z)).setPower(0.2F).setScale(0.6F));
     }
 
     public int countParticles() {
